package com.tzld.piaoquan.content.understanding.service.impl;

import com.tzld.piaoquan.content.understanding.model.param.ActionParam;
import com.tzld.piaoquan.content.understanding.service.Action;
import com.tzld.piaoquan.content.understanding.util.HttpClientUtil;
import com.tzld.piaoquan.content.understanding.util.HttpPoolClient;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Optional;

/**
 * @author supeng
 */
@Service(value = "geminiGenerateContentAction")
public class GeminiGenerateContentAction implements Action {

    @Value("${native.openai.url:http://openai.piaoquantv.com/aigc-server/gemini/generateContent}")
    private String geminiApiUrl;

    private static final HttpPoolClient httpPoolClient = HttpClientUtil.create(3000, 600000, 50, 200, 0, 3000);

    @Override
    public String execute(ActionParam param) {
        Optional<String> optionalS = httpPoolClient.postJson(geminiApiUrl, "");
        if (optionalS.isPresent()) {
            String content = optionalS.get();
            //过滤一些特殊格式
            content = content.replace("```json","").replace("```","");
            return content;
        }
        return null;
    }
}
