package com.tzld.piaoquan.content.understanding.service.impl;

import com.tzld.piaoquan.content.understanding.common.enums.ExceptionEnum;
import com.tzld.piaoquan.content.understanding.common.exception.CommonException;
import com.tzld.piaoquan.content.understanding.model.param.ActionParam;
import com.tzld.piaoquan.content.understanding.service.Action;
import com.tzld.piaoquan.content.understanding.service.PipelineService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * @author supeng
 */
@Slf4j
@Service
public class PipelineServiceImpl implements PipelineService {

    @Autowired
    private Map<String, Action> actionMap;

    @Override
    public String execute(Long pipelineId) {
        // 1.获取pipeline配置
        List<String> stepList = new ArrayList<>();
        // 2.按照步骤执行pipeline每一步动作
        String result = null;
        for (String step : stepList) {
            if (Objects.isNull(step)) {
                throw new CommonException(ExceptionEnum.DATA_ERROR, "step is null pipelineId=" + pipelineId);
            }
            Action action = actionMap.get(step);
            if (Objects.isNull(action)) {
                throw new CommonException(ExceptionEnum.DATA_ERROR, "action is null pipelineId=" + pipelineId);
            }
            ActionParam actionParam = new ActionParam();
            actionParam.setInput(result);
            result = action.execute(actionParam);
        }
        return result;
    }
}
